Index: issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.cpp	(revision 18301)
@@ -31,6 +31,6 @@
 	iomodel->FetchDataToInput(elements,SurfaceEnum);
 	iomodel->FetchDataToInput(elements,MaskIceLevelsetEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateCorrectionEnum,0.);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsFloatingiceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,VxEnum);
 	iomodel->FetchDataToInput(elements,VyEnum);
@@ -232,5 +232,5 @@
 	int         domaintype,dim;
 	IssmDouble  Jdet,dt;
-	IssmDouble  mb,mb_correction,bed,vz;
+	IssmDouble  gmb,fmb,mb,bed,phi,vz;
 	Element*    basalelement = NULL;
 	IssmDouble *xyz_list  = NULL;
@@ -266,7 +266,8 @@
 	basalelement->GetVerticesCoordinates(&xyz_list);
 	basalelement->FindParam(&dt,TimesteppingTimeStepEnum);
-	Input* mb_input            = basalelement->GetInput(BasalforcingsMeltingRateEnum);   _assert_(mb_input);
-	Input* mb_correction_input = basalelement->GetInput(BasalforcingsMeltingRateCorrectionEnum);
-	Input* base_input           = basalelement->GetInput(BaseEnum);                        _assert_(base_input);
+	Input* groundedice_input   = basalelement->GetInput(MaskGroundediceLevelsetEnum);              _assert_(groundedice_input);
+	Input* gmb_input           = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum);  _assert_(gmb_input);
+	Input* fmb_input           = basalelement->GetInput(BasalforcingsFloatingiceMeltingRateEnum);  _assert_(fmb_input);
+	Input* base_input          = basalelement->GetInput(BaseEnum);                                 _assert_(base_input);
 	Input* vz_input      = NULL;
 	switch(dim){
@@ -276,5 +277,4 @@
 	}
 
-	/*Initialize mb_correction to 0, do not forget!:*/
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss=basalelement->NewGauss(2);
@@ -286,12 +286,12 @@
 
 		vz_input->GetInputValue(&vz,gauss);
-		mb_input->GetInputValue(&mb,gauss);
+		gmb_input->GetInputValue(&gmb,gauss);
+		fmb_input->GetInputValue(&fmb,gauss);
 		base_input->GetInputValue(&bed,gauss);
-		if(mb_correction_input)
-		 mb_correction_input->GetInputValue(&mb_correction,gauss);
-		else
-		 mb_correction=0.;
-
-		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(bed+dt*(mb-mb_correction) + dt*vz)*basis[i];
+		groundedice_input->GetInputValue(&phi,gauss);
+		if(phi>0) mb=gmb;
+		else mb=fmb;
+
+		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(bed+dt*(mb) + dt*vz)*basis[i];
 	}
 
@@ -363,4 +363,7 @@
 void FreeSurfaceBaseAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
 	   _error_("not implemented yet");
+}/*}}}*/
+void FreeSurfaceBaseAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void FreeSurfaceBaseAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/FreeSurfaceBaseAnalysis.h	(revision 18301)
@@ -29,4 +29,5 @@
 		void GetBprime(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.cpp	(revision 18301)
@@ -367,4 +367,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void FreeSurfaceTopAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void FreeSurfaceTopAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/FreeSurfaceTopAnalysis.h	(revision 18301)
@@ -29,4 +29,5 @@
 		void GetBprime(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/GiaAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/GiaAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/GiaAnalysis.cpp	(revision 18301)
@@ -57,4 +57,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void GiaAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void GiaAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 	_error_("not implemented yet");
Index: issm/trunk/src/c/analyses/GiaAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/GiaAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/GiaAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.cpp	(revision 18301)
@@ -316,4 +316,7 @@
 void HydrologyDCEfficientAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
 	element->GetSolutionFromInputsOneDof(solution,EplHeadEnum);
+}/*}}}*/
+void HydrologyDCEfficientAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void HydrologyDCEfficientAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
@@ -556,5 +559,5 @@
 				if(EPL_N<0.0)EPL_N=0.0;
 				/*Get then the square of the gradient of EPL heads*/
-				EPLgrad2 = (epl_slopeX[i]*epl_slopeX[i]+epl_slopeY[i]*epl_slopeY[i]);
+				EPLgrad2 = (epl_slopeX[i]+epl_slopeY[i])*(epl_slopeX[i]+epl_slopeY[i]);
 				
 				/*And proceed to the real thing*/
Index: issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyDCEfficientAnalysis.h	(revision 18301)
@@ -28,4 +28,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 18301)
@@ -84,5 +84,5 @@
 	iomodel->FetchDataToInput(elements,BaseEnum);
 	iomodel->FetchDataToInput(elements,MaskIceLevelsetEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,HydrologydcBasalMoulinInputEnum);
 	iomodel->FetchDataToInput(elements,SedimentHeadEnum);
@@ -307,6 +307,6 @@
 	Input* thickness_input   = basalelement->GetInput(ThicknessEnum);
 	Input* base_input        = basalelement->GetInput(BaseEnum);
-	Input* water_input       = basalelement->GetInput(BasalforcingsMeltingRateEnum);    _assert_(water_input);
-	if(dt!= 0.){old_wh_input = basalelement->GetInput(SedimentHeadOldEnum);             _assert_(old_wh_input);}
+	Input* water_input       = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(water_input);
+	if(dt!= 0.){old_wh_input = basalelement->GetInput(SedimentHeadOldEnum);                     _assert_(old_wh_input);}
 
 	IssmDouble sediment_storing    = SedimentStoring(basalelement);
@@ -393,4 +393,7 @@
 	element->GetSolutionFromInputsOneDof(solution,SedimentHeadEnum);
 }/*}}}*/
+void HydrologyDCInefficientAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void HydrologyDCInefficientAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
@@ -601,5 +604,7 @@
 		sed_trans_input->GetInputValue(&sediment_transmitivity,gauss);
 		element->FindParam(&leakage,HydrologydcLeakageFactorEnum);
+		
 		transfer=(sediment_transmitivity)/(sediment_thickness*leakage);
+		
 		/* if(epl_head>sed_head){ */
 		/* 	h_max=GetHydrologyDCInefficientHmax(element,gauss,thickness_input,base_input); */
@@ -616,4 +621,5 @@
 		/* 	//transfer=(sediment_storing*sediment_transmitivity)/(sediment_thickness*leakage); */
 		/* } */
+		
 		break;
 	default:
Index: issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyDCInefficientAnalysis.h	(revision 18301)
@@ -28,4 +28,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/HydrologyShreveAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/HydrologyShreveAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyShreveAnalysis.cpp	(revision 18301)
@@ -50,5 +50,5 @@
 	iomodel->FetchDataToInput(elements,MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(elements,MaskGroundediceLevelsetEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,WatercolumnEnum);
 
@@ -205,6 +205,6 @@
 	element->GetVerticesCoordinates(&xyz_list);
 	element->FindParam(&dt,TimesteppingTimeStepEnum);
-	Input* mb_input   = element->GetInput(BasalforcingsMeltingRateEnum); _assert_(mb_input);
-	Input* oldw_input = element->GetInput(WaterColumnOldEnum);           _assert_(oldw_input);
+	Input* mb_input   = element->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(mb_input);
+	Input* oldw_input = element->GetInput(WaterColumnOldEnum);                      _assert_(oldw_input);
 
 	/*Initialize mb_correction to 0, do not forget!:*/
@@ -292,4 +292,7 @@
 	element->GetSolutionFromInputsOneDof(solution,WatercolumnEnum);
 }/*}}}*/
+void HydrologyShreveAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void HydrologyShreveAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/HydrologyShreveAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/HydrologyShreveAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/HydrologyShreveAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.cpp	(revision 18301)
@@ -199,4 +199,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void L2ProjectionBaseAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void L2ProjectionBaseAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/L2ProjectionBaseAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.cpp	(revision 18301)
@@ -229,4 +229,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void L2ProjectionEPLAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void L2ProjectionEPLAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 	int inputenum,domaintype;
Index: issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/L2ProjectionEPLAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/LevelsetAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/LevelsetAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/LevelsetAnalysis.cpp	(revision 18301)
@@ -89,11 +89,17 @@
 ElementMatrix* LevelsetAnalysis::CreateKMatrix(Element* element){/*{{{*/
 
+	if(!element->IsOnBase()) return NULL;
 	_error_("not implemented yet");
 }/*}}}*/
 ElementVector* LevelsetAnalysis::CreatePVector(Element* element){/*{{{*/
+	
+	if(!element->IsOnBase()) return NULL;
 	_error_("not implemented yet");
 }/*}}}*/
 void LevelsetAnalysis::GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element){/*{{{*/
 	_error_("not implemented yet");
+}/*}}}*/
+void LevelsetAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void LevelsetAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/LevelsetAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/LevelsetAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/LevelsetAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/LsfReinitializationAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/LsfReinitializationAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/LsfReinitializationAnalysis.cpp	(revision 18301)
@@ -283,4 +283,7 @@
 	xDelete<int>(doflist);
 
+}/*}}}*/
+void LsfReinitializationAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
 }/*}}}*/
 void LsfReinitializationAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
Index: issm/trunk/src/c/analyses/LsfReinitializationAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/LsfReinitializationAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/LsfReinitializationAnalysis.h	(revision 18301)
@@ -26,5 +26,6 @@
 	ElementMatrix* CreateKMatrix(Element* element);
 	ElementVector* CreatePVector(Element* element);
-	void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 	void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 	void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/MasstransportAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/MasstransportAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/MasstransportAnalysis.cpp	(revision 18301)
@@ -64,6 +64,6 @@
 	iomodel->FetchDataToInput(elements,MaskIceLevelsetEnum);
 	iomodel->FetchDataToInput(elements,MaskGroundediceLevelsetEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateCorrectionEnum,0.);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsFloatingiceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,VxEnum);
 	iomodel->FetchDataToInput(elements,VyEnum);
@@ -71,12 +71,4 @@
 	if(stabilization==3){
 		iomodel->FetchDataToInput(elements,MasstransportSpcthicknessEnum); //for DG, we need the spc in the element
-	}
-
-	if(dakota_analysis){
-		elements->InputDuplicate(BaseEnum,QmuBaseEnum);
-		elements->InputDuplicate(ThicknessEnum,QmuThicknessEnum);
-		elements->InputDuplicate(SurfaceEnum,QmuSurfaceEnum);
-		elements->InputDuplicate(MaskIceLevelsetEnum,QmuMaskIceLevelsetEnum);
-		if(isgroundingline) elements->InputDuplicate(MaskGroundediceLevelsetEnum,QmuMaskGroundediceLevelsetEnum);
 	}
 
@@ -115,4 +107,15 @@
 		case SMBhenningEnum:
 			iomodel->FetchDataToInput(elements,SurfaceforcingsSmbrefEnum,0.);
+			break;
+		case SMBcomponentsEnum:
+			iomodel->FetchDataToInput(elements,SurfaceforcingsAccumulationEnum,0.);
+			iomodel->FetchDataToInput(elements,SurfaceforcingsEvaporationEnum,0.);
+			iomodel->FetchDataToInput(elements,SurfaceforcingsRunoffEnum,0.);
+			break;
+		case SMBmeltcomponentsEnum:
+			iomodel->FetchDataToInput(elements,SurfaceforcingsAccumulationEnum,0.);
+			iomodel->FetchDataToInput(elements,SurfaceforcingsEvaporationEnum,0.);
+			iomodel->FetchDataToInput(elements,SurfaceforcingsMeltEnum,0.);
+			iomodel->FetchDataToInput(elements,SurfaceforcingsRefreezeEnum,0.);
 			break;
 		default:
@@ -513,5 +516,5 @@
 	/*Intermediaries */
 	IssmDouble  Jdet,dt;
-	IssmDouble  ms,mb,mb_correction=0.,thickness;
+	IssmDouble  ms,mb,gmb,fmb,thickness,phi;
 	IssmDouble* xyz_list = NULL;
 
@@ -526,10 +529,10 @@
 	element->GetVerticesCoordinates(&xyz_list);
 	element->FindParam(&dt,TimesteppingTimeStepEnum);
-	Input* mb_correction_input = element->GetInput(BasalforcingsMeltingRateCorrectionEnum);
-	Input* mb_input            = element->GetInput(BasalforcingsMeltingRateEnum);     _assert_(mb_input);
-	Input* ms_input            = element->GetInput(SurfaceforcingsMassBalanceEnum);   _assert_(ms_input);
-	Input* thickness_input     = element->GetInput(ThicknessEnum);                    _assert_(thickness_input);
-
-	/*Initialize mb_correction to 0, do not forget!:*/
+	Input* gmb_input           = element->GetInput(BasalforcingsGroundediceMeltingRateEnum);  _assert_(gmb_input);
+	Input* fmb_input           = element->GetInput(BasalforcingsFloatingiceMeltingRateEnum);  _assert_(fmb_input);
+	Input* groundedice_input   = element->GetInput(MaskGroundediceLevelsetEnum);              _assert_(groundedice_input);
+	Input* ms_input            = element->GetInput(SurfaceforcingsMassBalanceEnum);           _assert_(ms_input);
+	Input* thickness_input     = element->GetInput(ThicknessEnum);                            _assert_(thickness_input);
+
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss=element->NewGauss(2);
@@ -541,10 +544,12 @@
 
 		ms_input->GetInputValue(&ms,gauss);
-		mb_input->GetInputValue(&mb,gauss);
+		gmb_input->GetInputValue(&gmb,gauss);
+		fmb_input->GetInputValue(&fmb,gauss);
+		groundedice_input->GetInputValue(&phi,gauss);
 		thickness_input->GetInputValue(&thickness,gauss);
-		if(mb_correction_input)
-		 mb_correction_input->GetInputValue(&mb_correction,gauss);
-
-		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(thickness+dt*(ms-mb-mb_correction))*basis[i];
+		if(phi>0.) mb=gmb;
+		else mb=fmb;
+
+		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(thickness+dt*(ms-mb))*basis[i];
 	}
 
@@ -562,5 +567,5 @@
 	/*Intermediaries */
 	IssmDouble  Jdet,dt;
-	IssmDouble  ms,mb,mb_correction=0.,thickness;
+	IssmDouble  ms,mb,gmb,fmb,thickness,phi;
 	IssmDouble* xyz_list = NULL;
 
@@ -575,10 +580,10 @@
 	element->GetVerticesCoordinates(&xyz_list);
 	element->FindParam(&dt,TimesteppingTimeStepEnum);
-	Input* mb_correction_input = element->GetInput(BasalforcingsMeltingRateCorrectionEnum);
-	Input* mb_input            = element->GetInput(BasalforcingsMeltingRateEnum);     _assert_(mb_input);
-	Input* ms_input            = element->GetInput(SurfaceforcingsMassBalanceEnum);   _assert_(ms_input);
-	Input* thickness_input     = element->GetInput(ThicknessEnum);                    _assert_(thickness_input);
-
-	/*Initialize mb_correction to 0, do not forget!:*/
+	Input* gmb_input           = element->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(gmb_input);
+	Input* fmb_input           = element->GetInput(BasalforcingsFloatingiceMeltingRateEnum); _assert_(fmb_input);
+	Input* ms_input            = element->GetInput(SurfaceforcingsMassBalanceEnum);          _assert_(ms_input);
+	Input* groundedice_input   = element->GetInput(MaskGroundediceLevelsetEnum);             _assert_(groundedice_input);
+	Input* thickness_input     = element->GetInput(ThicknessEnum);                           _assert_(thickness_input);
+
 	/* Start  looping on the number of gaussian points: */
 	Gauss* gauss=element->NewGauss(2);
@@ -590,10 +595,12 @@
 
 		ms_input->GetInputValue(&ms,gauss);
-		mb_input->GetInputValue(&mb,gauss);
+		gmb_input->GetInputValue(&gmb,gauss);
+		fmb_input->GetInputValue(&fmb,gauss);
+		groundedice_input->GetInputValue(&phi,gauss);
 		thickness_input->GetInputValue(&thickness,gauss);
-		if(mb_correction_input)
-		 mb_correction_input->GetInputValue(&mb_correction,gauss);
-
-		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(thickness+dt*(ms-mb-mb_correction))*basis[i];
+		if(phi>0) mb=gmb;
+		else mb=fmb;
+
+		for(int i=0;i<numnodes;i++) pe->values[i]+=Jdet*gauss->weight*(thickness+dt*(ms-mb))*basis[i];
 	}
 
@@ -664,4 +671,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void MasstransportAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void MasstransportAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
Index: issm/trunk/src/c/analyses/MasstransportAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/MasstransportAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/MasstransportAnalysis.h	(revision 18301)
@@ -33,4 +33,5 @@
 		void GetBprime(IssmDouble* B,Element* element,int dim,IssmDouble* xyz_list,Gauss* gauss);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/MeltingAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/MeltingAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/MeltingAnalysis.cpp	(revision 18301)
@@ -43,5 +43,5 @@
 	iomodel->FetchDataToInput(elements,MaterialsRheologyBEnum);
 	iomodel->FetchDataToInput(elements,MaterialsRheologyNEnum);
-	iomodel->FetchDataToInput(elements,BasalforcingsMeltingRateEnum);
+	iomodel->FetchDataToInput(elements,BasalforcingsGroundediceMeltingRateEnum);
 	iomodel->FetchDataToInput(elements,PressureEnum);
 	
@@ -151,6 +151,9 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void MeltingAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void MeltingAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
-	element->InputUpdateFromSolutionOneDof(solution,BasalforcingsMeltingRateEnum);
+	element->InputUpdateFromSolutionOneDof(solution,BasalforcingsGroundediceMeltingRateEnum);
 }/*}}}*/
 void MeltingAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/
Index: issm/trunk/src/c/analyses/MeltingAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/MeltingAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/MeltingAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/MeshdeformationAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/MeshdeformationAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/MeshdeformationAnalysis.cpp	(revision 18301)
@@ -45,4 +45,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void MeshdeformationAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void MeshdeformationAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 	_error_("not implemented yet");
Index: issm/trunk/src/c/analyses/MeshdeformationAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/MeshdeformationAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/MeshdeformationAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.cpp	(revision 18301)
@@ -172,4 +172,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void SmoothedSurfaceSlopeXAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void SmoothedSurfaceSlopeXAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 	element->InputUpdateFromSolutionOneDof(solution,SurfaceSlopeXEnum);
Index: issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h	(revision 18081)
+++ issm/trunk/src/c/analyses/SmoothedSurfaceSlopeXAnalysis.h	(revision 18301)
@@ -27,4 +27,5 @@
 		ElementVector* CreatePVector(Element* element);
 		void GetSolutionFromInputs(Vector<IssmDouble>* solution,Element* element);
+		void GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index);
 		void InputUpdateFromSolution(IssmDouble* solution,Element* element);
 		void UpdateConstraints(FemModel* femmodel);
Index: issm/trunk/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp	(revision 18081)
+++ issm/trunk/src/c/analyses/SmoothedSurfaceSlopeYAnalysis.cpp	(revision 18301)
@@ -171,4 +171,7 @@
 	   _error_("not implemented yet");
 }/*}}}*/
+void SmoothedSurfaceSlopeYAnalysis::GradientJ(Vector<IssmDouble>* gradient,Element* element,int control_type,int control_index){/*{{{*/
+	_error_("Not implemented yet");
+}/*}}}*/
 void SmoothedSurfaceSlopeYAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 	element->InputUpdateFromSolutionOneDof(solution,SurfaceSlopeYEnum);
